Attribute VB_Name = "Module1"
Global PrgRun As Boolean 'Flag = Programm luft

Private hrc As Long 'Handle fr den OpenGL Gertekontext
Public Sub Main()
   Dim frm As Form
   
   PrgRun = True 'Flag = das Programm luft
   Set frm = New Form1 'Fenster fr OpenGL-Ausgabe
   frm.ScaleMode = vbPixels 'das Fenster mu zwingend in Pixel bemessen werden
   
   If CreateGLWindow(frm, 640, 480, 16) Then 'Fenster initialisieren
      Do 'Endlosschleife in der das Fenster laufend gelscht und neu aufgebaut wird.
         'Die Laufzeit dieser Schleife ist ausschlaggebend, wieviele Objekt gezeichnet werden knnen
         glClear clrColorBufferBit Or clrDepthBufferBit ' lscht das Fenster und den Tiefenpuffer
         glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
         
'--- neuer Code seit der Einfhrung ---

'ab hier zeichnen wir ein Dreieck in unser Fenster
         glTranslatef -1.5, 0#, -6#  'Setzt den neuen Zeichenpunkt. Ab dieser Koordinate werden nun alle Zeichenoperationen berechnet
         'Das heit wir verschieben den Punkt um 1,5 Einheiten nach Links und 6 Einheiten "in den Bildschirm"
         
         glBegin bmTriangles 'Anfang eines Dreiecks
            glColor3f 1#, 0#, 0# 'setzt die Zeichenfarbe auf Rot
            glVertex3f 0#, 1#, 0# 'obere Ecke
            glColor3f 0#, 1#, 0# 'setzt die Zeichenfarbe auf Grn
            glVertex3f -1#, -1#, 0# 'untere linke Ecke
            glColor3f 0#, 0#, 1# 'setzt die Zeichenfarbe auf Blau
            glVertex3f 1#, -1#, 0# 'untere rechte Ecke
         glEnd 'Ende des Dreiecks

         glTranslatef 3#, 0#, 0# 'Zeichenpunkt um 3 Einheiten nach rechts verschieben
      
         glColor3f 0.7, 0.7, 1#   'setzt die Zeichenfarbe einmal auf Hellblau fr alle Ecken
         glBegin bmQuads 'Anfang eines Vierecks
            glVertex3f -1#, 1#, 0# 'linke obere Ecke
            glVertex3f 1#, 1#, 0# 'rechte obere Ecke
            glVertex3f 1#, -1#, 0# 'untere rechte Ecke
            glVertex3f -1#, -1#, 0# 'untere linke Ecke
         glEnd 'Ende des Vierecks

'--- Ende neuer Code seit der Einfhrung
         
         SwapBuffers (frm.hDC) 'Puffer tauschen (Double Buffering)
         DoEvents
      Loop While PrgRun 'Programm nur beenden, wenn PrgRun = False
      'PrgRun ist Global definiert und wird im KeyDown-Ereignis von Form1 bei drcken von Escape gesetzt.
      'alles freigeben und Programm beenden
      If hrc <> 0 Then 'hatten wir einen Gertekontext fr OpenGL?
         wglMakeCurrent 0, 0 'Freigeben des Gertekontexts
         wglDeleteContext (hrc) 'Freigeben des Renderingkontexts
      End If
      Unload frm
      Set frm = Nothing
      End
   End If
End Sub

Public Function CreateGLWindow(frm As Form, Width As Integer, Height As Integer, Bits As Integer) As Boolean
   Dim pfd As PIXELFORMATDESCRIPTOR ' pfd erklrt Windows, wie das Fenster beschaffen sein soll
   Dim PixelFormat As GLuint ' enthlt das Ergebnis vom Versuch, ein Fenster mit den gegebenen Parametern zu erstellen
      
   pfd.cColorBits = Bits 'Farbtiefe
   pfd.cDepthBits = 16 '16 Bit Tiefenpuffer
   'Der Tiefenpuffer enthlt die Entfernung eines Pixels zur Kamera (Betrachter).
   'Er verhindert, da Objekte im Hintergrund beim Zeichnen Objekte im Vordergund berlagern.
   pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
   'PFD_DRAW_TO_WINDOW = das Format mu als Fenster sichtbar sein knnen
   'PFD_SUPPORT_OPENGL = das Format mu OpenGL untersttzen
   'PFD_DOUBLEBUFFER = das Foramt mu Double Buffering untersttzen
   pfd.iLayerType = PFD_MAIN_PLANE 'Die Hauptebene auf der gezeichnt wird.
   pfd.iPixelType = PFD_TYPE_RGBA 'Pixel werden im RGBA Modus dargestellt.
   'RGB ist mit VB identisch. Fr A wird ein Alpha-Wert fr die Transparenz bergeben
   pfd.nSize = Len(pfd) 'Gre der Struktur sollte natrlich stimmen
   pfd.nVersion = 1 'Versionsnummer

   PixelFormat = ChoosePixelFormat(frm.hDC, pfd) 'Windows nach einem oben beschriebenen Pixelformat fragen
   If PixelFormat <> 0 Then
      'Windows hat ein entsprechendes Format gefunden
      If SetPixelFormat(frm.hDC, PixelFormat, pfd) <> 0 Then
         'Einrichten des Pixelformates war erfolgreich
         hrc = wglCreateContext(frm.hDC)
         If hrc <> 0 Then
            'ein Rendering Kontext wurde erstellt
            If wglMakeCurrent(frm.hDC, hrc) <> 0 Then
               'Der Kontext wurde aktiviert
               frm.Show 'Fenster anzeigen
               glShadeModel smSmooth 'schaltet schne Farbbergange ein
               glClearColor 0#, 0#, 0#, 0# 'schwarzer Hintergrund
               glClearDepth 1# 'Tiefenpuffer zurcksetzten (spter mehr)
               glEnable glcDepthTest 'Aktivierung des Tiefentests (spter mehr)
               glDepthFunc cfLEqual 'Typ des Tiefentests (spter mehr)
               glHint htPerspectiveCorrectionHint, hmNicest 'Art der Perspectivenansicht
               'hmNicest = beste Ansicht / hmFastest = schnellste Darstellung
               CreateGLWindow = True
            End If
         End If
      End If
   End If
End Function

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)
   'Anpassen der Gre und Initialisierung des OpenGL-Fensters
   If Height = 0 Then 'Die Fensterhhe mu grer 0 sein
       Height = 1 'sonst kommt es zu einem Division by Zero Fehler
   End If
   glViewport 0, 0, Width, Height 'leeren des aktuellen Viewports
   glMatrixMode mmProjection 'Auswahl der Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck

   gluPerspective 45#, Width / Height, 0.1, 100# 'Berechnung des aktuellen Seitenverhltnisses des Fensters

   glMatrixMode mmModelView 'Auswahl der Modelview Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
End Sub


